Invoices
List invoices with filtering and pagination
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Query Parameters
Pagination cursor
Number of items per page (1-100)
Start date (YYYY-MM-DD)
End date (YYYY-MM-DD)
Filter by status
Search query
Response Body
application/json
application/json
curl -X GET "https://example.com/v1/invoices"{
"data": [
{
"id": "string",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"created_at": "string",
"updated_at": "string",
"template": null,
"token": "string",
"reminder_sent_at": "string",
"paid_at": "string",
"reminder_sent_to": "string",
"viewed_at": "string",
"is_recurring_inflow": true,
"recurring_contract_id": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"reference_invoice_id": "string",
"source_quote_id": "string",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"downloads": {
"pdf": "string",
"ubl": "string",
"bundle": "string"
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
],
"meta": {
"count": 0,
"next_cursor": "string"
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Create a new invoice draft
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Header Parameters
Optional idempotency key (sent as the Idempotency-Key header; case-insensitive). Reusing the same key with an identical body replays the original response; reusing it with a different body returns 409. Keys are retained for 24 hours.
Request Body
application/json
TypeScript Definitions
Use the request body type in TypeScript.
Response Body
application/json
application/json
application/json
application/json
application/json
application/json
application/json
application/json
curl -X POST "https://example.com/v1/invoices" \ -H "Content-Type: application/json" \ -d '{}'{
"data": {
"id": "string",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"created_at": "string",
"updated_at": "string",
"template": null,
"token": "string",
"reminder_sent_at": "string",
"paid_at": "string",
"reminder_sent_to": "string",
"viewed_at": "string",
"is_recurring_inflow": true,
"recurring_contract_id": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"reference_invoice_id": "string",
"source_quote_id": "string",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"downloads": {
"pdf": "string",
"ubl": "string",
"bundle": "string"
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}List all invoice templates for the current organization
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Response Body
application/json
application/json
curl -X GET "https://example.com/v1/invoices/templates"{
"data": [
{
"id": "string",
"name": "string",
"currency": "string",
"tax_rate": 0,
"tax_type": "string",
"invoice_number_prefix": "string",
"created_at": "string"
}
]
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Create a new invoice template (document_template + invoice settings).
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Request Body
application/json
TypeScript Definitions
Use the request body type in TypeScript.
Response Body
application/json
application/json
curl -X POST "https://example.com/v1/invoices/templates" \ -H "Content-Type: application/json" \ -d '{ "name": "string" }'{
"data": {
"id": "string"
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Calculate a provider-ready invoice without creating an invoice, customer, token, idempotency reservation, or artifact.
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Request Body
application/json
TypeScript Definitions
Use the request body type in TypeScript.
Response Body
application/json
application/json
application/json
application/json
application/json
application/json
application/json
curl -X POST "https://example.com/v1/invoices/preview" \ -H "Content-Type: application/json" \ -d '{}'{
"data": {
"object": "invoice_preview",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"template": null,
"template_id": "string",
"paid_at": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Get a single invoice by ID
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Path Parameters
Response Body
application/json
application/json
application/json
curl -X GET "https://example.com/v1/invoices/string"{
"data": {
"id": "string",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"created_at": "string",
"updated_at": "string",
"template": null,
"token": "string",
"reminder_sent_at": "string",
"paid_at": "string",
"reminder_sent_to": "string",
"viewed_at": "string",
"is_recurring_inflow": true,
"recurring_contract_id": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"reference_invoice_id": "string",
"source_quote_id": "string",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"downloads": {
"pdf": "string",
"ubl": "string",
"bundle": "string"
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Update invoice fields
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Path Parameters
Request Body
application/json
TypeScript Definitions
Use the request body type in TypeScript.
Response Body
application/json
application/json
application/json
application/json
application/json
curl -X PATCH "https://example.com/v1/invoices/string" \ -H "Content-Type: application/json" \ -d '{}'{
"data": {
"id": "string",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"created_at": "string",
"updated_at": "string",
"template": null,
"token": "string",
"reminder_sent_at": "string",
"paid_at": "string",
"reminder_sent_to": "string",
"viewed_at": "string",
"is_recurring_inflow": true,
"recurring_contract_id": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"reference_invoice_id": "string",
"source_quote_id": "string",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"downloads": {
"pdf": "string",
"ubl": "string",
"bundle": "string"
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Delete an invoice by ID (only draft or cancelled invoices can be deleted)
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Path Parameters
Response Body
application/json
application/json
application/json
application/json
curl -X DELETE "https://example.com/v1/invoices/string"{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Download issued invoice artifacts as PDF, UBL XML, or ZIP.
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Path Parameters
Query Parameters
Response Body
application/json
application/json
application/json
curl -X GET "https://example.com/v1/invoices/string/download""string"{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}Finalize a draft invoice — freezes the legal entity / template snapshot, allocates a gap-free number from the document sequence, and transitions status from draft to unpaid.
Authorization
bearerAuth Session JWT or OAuth2 access token
In: header
Path Parameters
Response Body
application/json
application/json
application/json
application/json
application/json
curl -X POST "https://example.com/v1/invoices/string/finalize"{
"data": {
"id": "string",
"organization_id": "string",
"customer_id": "string",
"number": "string",
"status": "draft",
"date": "string",
"due_date": "string",
"subtotal": 0,
"tax": 0,
"total": 0,
"from_details": "string",
"to_details": "string",
"items": [
{
"name": "string",
"quantity": 0,
"price": 0,
"unit": "string",
"tax_rate": 0,
"tax_behavior": "inclusive",
"amount": 0,
"tax_amount": 0,
"tax_category": "standard",
"tax_exemption_reason": "string",
"tax_exemption_reason_code": "string",
"product_id": "0d012afa-f885-4e65-aeca-37e27701e2d1",
"product_price_id": "453079f2-dfb3-4e2b-b8f6-52db9da09b0d",
"kind": "goods",
"dispatched_from": "st"
}
],
"payment_details": "string",
"notes": "string",
"created_at": "string",
"updated_at": "string",
"template": null,
"token": "string",
"reminder_sent_at": "string",
"paid_at": "string",
"reminder_sent_to": "string",
"viewed_at": "string",
"is_recurring_inflow": true,
"recurring_contract_id": "string",
"recurring_series_id": "string",
"scheduled_send_at": "string",
"document_type": "invoice",
"reference_invoice_id": "string",
"source_quote_id": "string",
"service_period_start": "string",
"service_period_end": "string",
"buyer_reference": "string",
"contract_reference": "string",
"purchase_order_reference": "string",
"tax_point_date": "string",
"tax_point_date_code": "3",
"project_reference": "string",
"tender_or_lot_reference": "string",
"invoiced_object_identifier": "string",
"invoiced_object_scheme": "string",
"buyer_accounting_reference": "string",
"delivery_date": "string",
"external_invoice_id": "string",
"client_id": "string",
"metadata": {
"property1": null,
"property2": null
},
"downloads": {
"pdf": "string",
"ubl": "string",
"bundle": "string"
},
"customer": {
"id": "string",
"reference_id": "string",
"name": "string",
"email": "string",
"website": "string"
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}{
"error": {
"code": "string",
"message": "string",
"details": {
"property1": null,
"property2": null
}
}
}